import CacheProtocol from "./CacheProtocol";
export declare class Cache {
    readonly protocol: CacheProtocol;
    constructor(protocol: CacheProtocol);
    Cacheable(config: {
        cache: string;
        key: string;
        expire: undefined | number;
        condition?: string;
    }): (target: any, methodName: string, des: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>) => void;
    CachePut(config: {
        cache: string;
        key: string;
        expire: undefined | number;
        condition?: string;
    }): (target: any, methodName: string, des: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>) => void;
    CacheEvict(config: {
        cache: string;
        key: string;
        condition?: string;
    }): (target: any, methodName: string, des: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>) => void;
    CacheEvictMulti(config: {
        cache: string;
        foreach: string;
        key: string;
        condition?: string;
    }): (target: any, methodName: string, des: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>) => void;
    CacheEvictAll(config: {
        cache: string;
        condition?: string;
    }): (target: any, methodName: string, des: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>) => void;
    CacheableLock(config: {
        cache: string;
        key: string;
        expire: undefined | number;
        lockTime?: number;
        condition?: string;
    }): (target: any, methodName: string, des: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>) => void;
    CacheEvictLock(config: {
        cache: string;
        key: string;
        lockTime?: number;
        condition?: string;
    }): (target: any, methodName: string, des: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>) => void;
    CacheEvictMultiLock(config: {
        cache: string;
        foreach: string;
        key: string;
        lockTime?: number;
        condition?: string;
    }): (target: any, methodName: string, des: TypedPropertyDescriptor<(...args: any[]) => Promise<any>>) => void;
}
